*******************************************************************************;
* vO: P01-07-03.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: V߁@dr                                            *;
* gpړI: Williams̑dr                                                *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: Williams̑dr';
footnote 'Program: P01-07-03.SAS';

* ----- Williams̑dr;
%macro WILP;
  proc glm data=&DATA outstat=VAR noprint;
    class &GROUP; 
    model &Y=&GROUP/ss1;
  run;
  
  data VAR; set VAR;
    keep VAR DF;
    VAR=SS/DF; 
    if _TYPE_='ERROR' then output;
  run;
  
  proc sort data=&DATA; by &GROUP;
  run;
  
  proc summary data=&DATA;
    var &Y; 
    by &GROUP; 
    output out=OUT mean=MEAN n=N;
  run;
  
  proc transpose data=OUT out=N prefix=N;
    var N; 
    id &GROUP;
  run;
  
  proc transpose data=OUT out=MEAN prefix=M;
    var MEAN; 
    id &GROUP;
  run;
  
  data SUMMARY; merge N MEAN VAR;
  run;
  
  data SUMMARY;set SUMMARY; 
    drop S1-S100 NN1-NN100; 
    retain SIN 0;
    array NN(&G) N1-N&G; 
    array M(&G) M1-M&G; 
    array MM(&G) MM1-MM&G;
    
    MM1=M1;
    array S(10,10) S1-S100; 
    array NNN(10,10) NN1-NN100;

    do I=1 to &G-1;

      do J=1 to &G-1;
        s(I,J)=0;
        NNN(I,J)=0;
        do K=I to J; 
          S(I,J)=S(I,J)+M(K+1)*NN(K+1); 
          NNN(I,J)=NNN(I,J)+NN(K+1); 
        end;
        if NNN(I,J)^=0 then S(I,J)=S(I,J)/NNN(I,J);
      end;
    end;
    do J=1 to &G-1;
      MM(J+1)=M(J+1); 
      do I=1 to &G-1;
        if NNN(I,J)^=0 and 1=&TAIL then MM(J+1)=max(MM(J+1),S(I,J));
        if NNN(I,J)^=0 and 2=&TAIL then MM(J+1)=min(MM(j+1),S(I,J));
      end;
    end;

    do I=&G to 2 by -1;
      CONTROL=MM1;
      GROUP=I;
      ADJMEAN=MM(I);
      MEAN=M(I);
      T=(MM(i)-MM1)/(VAR*(1/NN(i)+1/N1))**0.5;
      if 2=&TAIL then T=T*(-1);
      WP=1-probmc('williams',T,.,DF,I-1);
      WTC=probmc('williams',.,1-&A,DF,I-1);
      STAR='';
      if WP<=&A then SIN=1;
      if SIN=1 then STAR='*';
      output;
      SIN=0;
    end;
  run;
  
  proc sort; by GROUP;run;
  
  proc print;
    var CONTROL GROUP MEAN ADJMEAN T WP WTC STAR;
  run;
%mend;

* ----- }Nϐ̒`;
%let DATA=D1;   * f[^Zbg;
%let G=4;         * Q̑;
%let A=0.05;      * LӐ;
%let GROUP=GROUP; * Q;
%let Y=RESP;      * ϐ;
%let TAIL=2;      * tail=1:upper tailed  tail2:lower tailed;

*-------------------------}Ns---;
data D1;
  do GROUP=1 to 4;
    do I=1 to 10;
      input RESP@@;
      output;
    end;
  end;
  drop I;
cards;   
153 153 152 156 158 151 151 150 148 157
158 152 152 152 151 151 157 147 155 146
153 146 138 152 140 146 156 142 147 153
137 139 141 141 143 133 147 144 151 156
;
RUN;

%WILP;

