*******************************************************************************;
* vO: P01-07-04.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: V߁@dr                                            *;
* gpړI: Steeľ(mpgbNłDunnett̑dr)              *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: Steeľ(mpgbNłDunnett̑dr)';
footnote 'Program: P01-07-04.SAS';

* ----- Tvf[^쐬;
data DAT1;
  keep GROUP ATAI;
  do GROUP=1 to 3;
    do ATAI=1 to 4;
      input FREQ @@;
      do LOOP=1 to FREQ;
        output;
      end;
    end;
  end;
  cards;
3  8 30 22
8  9 29 11
2 11 33 17
;
run ;

proc print data=DAT1;
run;

* ----- }Nϐ`;
%let NG=3; * Q̑;
%let TG=1; * ΏƌQƂQԍ;

* ----- Steeľ;
data TEMP1;set DAT1;
  GUN1=&TG;
  do GUN2=1 to &NG;
    if GROUP = GUN1 then output;
    if GROUP = GUN2 then output;
  end;
run;

proc sort data=TEMP1;
  by GUN1 GUN2;
run;

proc npar1way wilcoxon data=TEMP1 noprint;
  class GROUP;
  var ATAI;
  by GUN1 GUN2;
  output out=TEMP2;
run;

proc summary data=DAT1;
  var ATAI;
  class GROUP;
  output out=TEMP3 n=N;
run;

proc transpose data=TEMP3 out=TEMP4 prefix=N;
  var N;
  id GROUP;          /* ver1.1 */       
  where _type_=1;    /* ver1.1 */
run;

%let IG=%eval(&NG-1);

data TEMP5; set TEMP4;
  DF=.;
  array NN{&NG} N1-N&NG;
  array R{&IG}  R1-R&IG;
  K=0;
  do I=1 to &NG;
    if I ne &TG then do;
      K=K+1;
      R{K}=sqrt(NN{I}/(NN{I}+N&TG));
    end;
  end;
run;

data TEMP6; set TEMP2;
  DF=.;
run;

data TEMP7; merge TEMP5 TEMP6;
  by DF;
  Z=sqrt(_KW_);
  P=1-probmc('dunnett2',abs(Z),.,DF,&NG-1,of R1-R&IG);
run;

proc print data=TEMP7;
  var GUN1 GUN2 Z P;
run;
