*******************************************************************************;
* vO: P01-08-03.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: W߁@X̌                                        *;
* gpړI: Cochran-Armitagě                                            *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: Cochran-Armitagě';
footnote 'Program: P01-08-03.SAS';

* ----- Tvf[^쐬;
data DT02;
  keep DOSE EFFECT;
  do DOSE=0, 10, 20, 30;
    do EFFECT=1 to 0 by -1;
      input FREQ @@;
      do LOOP=1 to FREQ;
        output;
      end;
    end;
  end;
  cards;
27 63 30 60 24 66 45 45
;
run ;

option nodate;
title;

proc print data=DT02;
run;

title "FREQvVWɂCochran-Armitagě";
proc freq data=DT02 order=data;
  tables DOSE*EFFECT/noprint trend;
  exact trend;
  output out=OUT_CA trend;
run;

proc print data=OUT_CA;
run;

title "MULTTESTvVWɂCochran-Armitagě(Kߎ)";
proc multtest data=DT02 order=data out=OUT_CA;
  class DOSE;
  test ca(EFFECT/binomial uppertailed);
  contrast 'TREND' -3 -1 1 3;
run;

proc print data=OUT_CA;
run;

title "MULTTESTvVWɂCochran-Armitagě(EXACT)";
proc multtest data=DT02 order=data out=OUT_CA;
  class DOSE;
  test ca(EFFECT/permutation=1000 uppertailed);
  contrast 'TREND' -3 -1 1 3;
run;

proc print data=OUT_CA;
run;
