*******************************************************************************;
* vO: P01-09-01.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: X߁@ԉ                                        *;
* gpړI: Kaplan-Meier@ɂ鐶̐s                            *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;
           
* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title f=mincho 'Title: Kaplan-Meier@ɂ鐶̐';
footnote 'Program: P01-09-01.SAS';
           
* ----- tH[}bg쐬;
proc format;
  value TRTF    0='CONTROL ' 
                1='NEW-DRUG ';
  value CENSORF 0='CENSORED' 
                1='EVENT';
run;

* ----- Tvf[^쐬;

data KM;

  do TRT=0,1;
    do i=1 to 16;
      input TIME CENSOR @@;output;
  end;end;
  format TRT TRTF. CENSOR CENSORF.;
  keep TRT TIME CENSOR;
cards;
 4 1  5 1  7 1  7 1 12 1 14 0 17 1 20 1
22 1 31 1 34 0 34 1 43 1 45 0 50 1 52 1
 9 1 12 1 14 0 20 1 20 1 25 1 26 1 31 0
34 0 41 1 45 0 48 1 55 1 60 1 62 0 77 0
;
run;

proc print data=KM;
run;

* ----- LIFETESTvVWɂKaplan-Meier;
ods output ProductLimitEstimates = SURV ;
proc lifetest data=KM plots=(s,lls) outs=OUT atrisk;
  time TIME*CENSOR(0);
  strata TRT;
run;

proc sort data=OUT;
  by TRT;
run;

proc print data=OUT;
  by TRT;
run;

* ----- ݐϔ̃vbg;
proc lifetest data=KM plots=(s,lls) outs=OUT;
  time TIME*CENSOR(0);
  strata TRT;
run;

proc means max data=OUT noprint;
  class TRT;
  var SURVIVAL;   
  output out=A min=MIN_RATE;  
run;
data A;set A;
  if TRT^=.;
run;

data OUT;merge OUT A;by TRT;
   if SURVIVAL=. then SURVIVAL=MIN_RATE;   
run;

data OUT2;set OUT;
  RATE=1-SURVIVAL;
  output;
  if _CENSOR_ = 1 then do;
    RATE=RATE+0.025;
    output;
    RATE=RATE-0.025;
    output;
  end;
run;
  
proc gplot data=OUT2;
  plot RATE*TIME=TRT;
  symbol1 i=steplj color=red   l=1 v=none;
  symbol2 i=steplj color=black l=2 v=none;
run;
quit;
