*******************************************************************************;
* vO: P02-03-03.SAS                                                 *;
* eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *;
* eLXg̐: R߁@pʔ                                        *;
* gpړI: pʔ̗ᐔ߂iV~[VAo͋Ȑj        *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: pʔ̗ᐔ߂iV~[VAo͋Ȑj';
footnote 'Program: P02-03-03.SAS';

*--- V~[Vɂpʔ̗ᐔ݌v ---*;
/*-----p[^w---------------------------------------------------------*/
/*  ARGV   : eQ̗LiBlank؂ŗ񋓁j                            @@*/
/*  N      : ᐔ                                                             */
/*  ALPHA  : БLӐ(P̉ߌ)                                   @@*/
/* : 4Qł̗pʔz肵ĂBQقȂꍇ͏C      */
/* KvłB                                                               */
/*----------------------------------------------------------------------------*/
%macro CALC(ARGV,ALPHA,N);
  data D1;
    P_P=scan(&ARGV,1)/100; 
    P_L=scan(&ARGV,2)/100;
    P_M=scan(&ARGV,3)/100; 
    P_H=scan(&ARGV,4)/100;
    SEED=498999;
    N=&N;
    do LOOP=1 to 1000;
      N_P=RANBIN(SEED,N,P_P); 
      N_L=RANBIN(SEED,N,P_L);
      N_M=RANBIN(SEED,N,P_M); 
      N_H=RANBIN(SEED,N,P_H);
      do I=1 to N_P;
        EFF=1;
        GUN='0:P';
        OUTPUT;
      end;
      do I=N_P+1 to N;
        EFF=0;
        GUN='0:P';
        OUTPUT;
      end;
      do I=1 to N_L;
        EFF=1;
        GUN='1:L';
        OUTPUT;
      end;
      do I=N_L+1 to N;
        EFF=0;
        GUN='1:L';
        OUTPUT;
      end;
      do I=1 to N_M;
        EFF=1;
        GUN='2:M';
        OUTPUT;
      end;
      do I=N_M+1 to N;
        EFF=0;
        GUN='2:M';
        OUTPUT;
      end;
      do I=1 to N_H;
        EFF=1;
        GUN='3:H';
        OUTPUT;
      end;
      do I=N_H+1 to N;
        EFF=0;
        GUN='3:H';
        OUTPUT;
      end;
    end;
  run;

  proc freq data=D1 noprint;
    by LOOP;
    tables EFF*GUN/nocol norow nopercent trend noprint;
    exact trend;
    output out=_D1 trend;
  run;

  data _D1;set _D1;
    if &ALPHA>(XP2_TREN/2) then POWER=1;
    else POWER=0;
  run;

  proc means data=_D1 N MEAN noprint;
    var POWER;
    output out=_D2 N=SN MEAN=MEAN;
  run;

  data _D2;
    set _D2;
    N=&N;
    label SN='V~[V' N='ᐔ' MEAN='o';
  run;

  proc append base=D2 data=_D2;
  run;
%mend;

%CALC('15 25 35 35',0.025,10);
%CALC('15 25 35 35',0.025,20);
%CALC('15 25 35 35',0.025,30);
%CALC('15 25 35 35',0.025,40);
%CALC('15 25 35 35',0.025,50);
%CALC('15 25 35 35',0.025,60);
%CALC('15 25 35 35',0.025,70);
%CALC('15 25 35 35',0.025,80);
%CALC('15 25 35 35',0.025,90);
%CALC('15 25 35 35',0.025,100);

proc print data=D2 label;
  var SN N MEAN;
run;

* ----- o͋Ȑ̍쐬;
goption ftext = "lr oSVbN";

axis1 order=(0.0 to 1.0 by 0.2)
    minor=none
      length=30
      value=(h=1.5)
      label=(angle=90 rotate=0 h=1.5);
axis2 order=(0 to 100 by 10)
      minor=none
      length=75
      value=(h=1.5)
      label=(h=1.5)
      offset=(0.5, 1.0);


title  "o͋Ȑ";      
proc gplot data=D2;
  plot MEAN*N/vaxis=axis1
              haxis=axis2;
  symbol1 i=spline v=circle color=red;
run;

quit;

* ----- Work datasets̍폜;
proc datasets lib=work memtype=data kill noprint;
run;  

quit ;
